Project 1: Scanner Implementation by Steven Cartwright
Project Description
This project aims to implement a scanner for a simple programming language based on provided lexical definitions. The scanner reads input strings and tokenizes them based on the lexical rules specified. It returns one token at a time and handles various invocation methods, including reading from standard input or a file. The project also includes a testing driver to validate the scanner's functionality.

Implementation Details
Scanner Architecture
The scanner is implemented using a finite state machine (FSA) table and a driver function. The FSA table defines the transitions between states based on input characters, allowing the scanner to recognize different token types.

Token Representation
Each token is represented as a triplet {tokenID, tokenInstance, line# and char#}, where:

tokenID is the identifier for the token type.
tokenInstance is the actual token string.
line# and char# denote the line and character numbers where the token is found, respectively.

Running the Project
Ensure all source files are cleaned up and in the correct directory.
Run make to compile the project and generate the scanner executable.
Invoke the scanner executable with appropriate arguments to test the scanner's functionality.

Invocation
The scanner can be invoked using the following command:

scanner [file]

File Structure
scanner.cpp and scanner.h: Implement the scanner using the FSA table and define its interface.
testScanner.cpp and testScanner.h: Implement the testing driver to validate the scanner's functionality.
main.cpp: Process command-line arguments and call the testScanner function.
token.h: Define types and token representations.
Makefile: Compiles the project files into an executable named scanner.
README.md: Provides project overview, implementation details, and file structure.

Project Options
This implementation follows option 3, utilizing an FSA table for token recognition. The testing driver is integrated into the testScanner.cpp file
