#include <iostream>
#include <cstdio>
#include <cstring>

#include "scanner.h"
#include "testScanner.h"

int main(int argc, char* argv[]) {
    // Declare Variables
    FILE* filePointer = nullptr;
    const char* file = nullptr;

    // Check the number of command-line arguments
    if (argc > 2) {
        std::cout << "Fatal: Improper Usage!" << std::endl;
        std::cout << "Usage: scanner [fileName]" << std::endl;
        return 1; // Return error code indicating improper usage
    }

    // Process command-line arguments
    if (argc == 2) {
        file = argv[1];
        filePointer = fopen(file, "r");
        if (filePointer == nullptr) {
            perror("Fatal: Error Opening File!\n");
            return 1; // Return error code indicating file opening failure
        }
    } else {
        // Use keyboard input
        filePointer = stdin; // Set file pointer to stdin for keyboard input
    }

    // Test Scanner function call if file pointer is not nullptr
    if (filePointer != nullptr) {
        testScanner(filePointer);
        // Close file if not stdin
        if (filePointer != stdin) {
            fclose(filePointer);
        }
    }

    // End of main
    std::cout << "End of Main" << std::endl;
    return 0;
}

