// Steven Cartwright
// Project #1 4280

#include <stdio.h>
#include <ctype.h>

#include "token.h"
#include "testScanner.h"
#include "scanner.h"

const char* tokenNames[] = {
    "EOF Token",
    "Identifier",
    "Keyword",
    "Operator/Delimiter",
    "Integer",
    "Unknown"
};

void testScanner(FILE* filePointer) {
    // Declare Variables
    int line = 1;
    bool comment = false;
    int tokenIndex = 0;
    int tokenCount = 0;
    char nextChar;

    Token tokenArray[100];

    do {
        nextChar = fgetc(filePointer);

        // Skip Comments
        if (comment) {
            if (nextChar == '\n') {
                comment = false;
            }
            continue;
        }

        // Check for start of comment
        if (nextChar == '/') {
            if (fgetc(filePointer) == '/') {
                comment = true;
                continue;
            } else {
                fseek(filePointer, -1, SEEK_CUR);
            }
        }

        // Skip Spaces and Prints Token
        if (isspace(nextChar) || nextChar == EOF) {
            if (tokenIndex > 0) { // Found a token
                // Set token instance string and line #
                tokenArray[tokenCount].tokenInstance[tokenIndex] = '\0'; // Null-terminate the token string
                tokenArray[tokenCount].lineNum = line;

                // Find TokenId
                int tokenId = scanner(tokenArray[tokenCount].tokenInstance);

                // Print Result
                printf("%s\t%s\t%d\n", tokenNames[tokenId], tokenArray[tokenCount].tokenInstance, tokenArray[tokenCount].lineNum);

                // Increment line if new line is found
                if (nextChar == '\n' || nextChar == EOF) {
                    line++;
                }

                tokenIndex = 0;
                tokenCount++;
            }
            continue;
        }

        // Start of token
        tokenArray[tokenCount].tokenInstance[tokenIndex++] = nextChar;

    } while (nextChar != EOF);
}

