// Steven Cartwright
// Project #1 4280

#ifndef TOKEN_H
#define TOKEN_H

const int MAX_TOKEN_SIZE = 100;

// Enumeration for different types of tokens
typedef enum {
    // Special tokens
    EOF_Token, Unknown,

    // Identifiers and Integers
    Identifier, Integer,

    // Keywords
    Start, Stop, While, Repeat, Until, Label, Return, Cin, Cout, Tape, Jump, If, Then, Pick, Create, Set, Func,

    // Operators and delimiters
    Equal, LessThan, GreaterThan, EqualEqual, NotEqual, Colon, Assign, Plus, Minus, Asterisk, Slash, Caret, Dot, 
    OpenParen, CloseParen, Comma, OpenBrace, CloseBrace, Semicolon, OpenBracket, CloseBracket, Or, And
} TokenId;

// Struct to represent a token
typedef struct {
    TokenId tokenId;
    char tokenInstance[MAX_TOKEN_SIZE];
    int lineNum;
    int charNum;  // Character number in the line
} Token;

#endif // TOKEN_H

